#pragma once
#include <iostream>
#include <string>
#include "Structures.h"
#include <vector>
#include <set>
#include <unordered_set>
#include <ranges>
#include <fstream>
#include <algorithm>

class MeshLoader
{
protected:
    std::vector<Node> Nodes;
    std::vector<FiniteElement> FiniteElements;
    std::vector<BoundaryFiniteElement> BoundaryFiniteElements;
public:

    //!!! Где виртуальный деструктор? ---добавил
    virtual ~MeshLoader() = default;

    virtual void LoadMesh(const std::string& path) = 0; //!!! Строки передаются по ссылке на константу  ---исправил
    std::vector<Node>& getNodes();
    std::vector<FiniteElement>& getFiniteElements();
    std::vector<BoundaryFiniteElement>& getBoundaryFiniteElements();
    std::vector<FiniteElement> findElem(int id_1, int id_2);
    std::vector<FiniteElement> findElem(int id_1, int id_2, int id_3);
    std::vector<Node> getNodesByBoundaryFiniteElementId(int id);
    std::vector<FiniteElement> getElementsByBoundaryId(int id);
    std::vector<BoundaryFiniteElement> getsBoundaryFiniteElementByBoundaryId(int id);
    std::vector<std::set<int>> getNodeNeighbours();
    void insertCenterNode();
    void printSmallAngles(const std::string& filepath);
    const std::vector<double>& findNodeRanges(int id);
};
std::ostream& operator<<(std::ostream& stream, MeshLoader& mesh);