﻿#include "AneuMeshLoader.h"
#include <iostream>


//!!! Задание на защиту (не удалять!)
//!!! Реализовать на основе std::ranges.
//!!! 1. Создать контейнер всех тетраэдров.        ~~~ В FiniteElements хранятся тетраэдры, так что использую его
//!!! 2. Используя потоковый итератор, вывести в файл (за один pipeline)
//!!!    списки ID узлов первых 10 тетраэдров, у которых минимальный другранный угол меньше 10 грудусов.


int main(int argc, char* argv[])
{
    setlocale(LC_ALL, "rus");
    AneuMeshLoader mesh;
    std::string path;
    try {
        std::cout << "File import: ";
        if (argc > 1)   std::cout << (path = argv[1]) << std::endl;
        else            std::cin >> (path);

        mesh.LoadMesh(path);
    }
    catch (std::exception ex)
    {
        std::cout << ex.what() << std::endl;
    }
    
    std::cout << mesh;

    std::vector<FiniteElement> elements_vector;
    std::vector<Node> nodes_vector;
    std::vector<std::set<int>> neighbours;
    std::vector<BoundaryFiniteElement> surfaces_vector;

    std::cout << "\n\nResult of printSmallAngles function are in file \"output.txt\"\n";
    mesh.printSmallAngles("output.txt");
    /*
    std::cout << "\n\nResult of find Elements by id(2, 4, 8) function:\n";
    elements_vector = mesh.findElem(2, 4, 8);
    for (auto i : elements_vector)
        std::cout << i;
    elements_vector.clear();

    std::cout << "\nResult of find Elements by edge(2, 8) function:\n";
    elements_vector = mesh.findElem(2, 8);
    for (auto i : elements_vector)
        std::cout << i;
    elements_vector.clear();

    std::cout << "\nResult of getNodesByBoundaryFiniteElementId(6) function:\n";
    nodes_vector = mesh.getNodesByBoundaryFiniteElementId(6);
    for (auto i : nodes_vector)
        std::cout << i;
    nodes_vector.clear();

    std::cout << "\nResult of getElementsByBoundaryId(1) function:\n";
    elements_vector = mesh.getElementsByBoundaryId(1);
    for (auto i : elements_vector)
        std::cout << i;
    elements_vector.clear();

    std::cout << "\nResult of getsBoundaryFiniteElementByBoundaryId(1) function:\n";
    surfaces_vector = mesh.getsBoundaryFiniteElementByBoundaryId(1);
    for (auto i : surfaces_vector)
        std::cout << i;
    surfaces_vector.clear();

    std::cout << "\nResult of getNodeNeighbours() function:\n";
    neighbours = mesh.getNodeNeighbours();
    for (auto i = 0; i < neighbours.size(); ++i) {
        std::cout << "Neighbours for Node with ID : " << i + 1 << std::endl;
        for (const auto& j : neighbours[i]) {
            std::cout << j << std::endl;
        }
    }
    neighbours.clear();

    std::cout << "\nResult of insertCenterNode() function:\n";
    mesh.insertCenterNode();

    std::cout << mesh;*/

    std::cin.get();
    std::cin.get();
    return 0;
}
